#!/bin/sh

PROTOCOL="2c"
COMMUNITY="traffic"
HOSTNAME="192.168.0.1"
OID=".1.3.6.1.4.1.2021.8.1.100.101"
CUT="/usr/bin/cut"
ECHO="/bin/echo"
GREP="/bin/grep"
SNMPWALK="/usr/bin/snmpwalk"

getting_fields () {
  DATA=$($SNMPWALK -v $PROTOCOL -c $COMMUNITY $HOSTNAME $OID \
  | $CUT -d '"' -f 2 | $GREP $IO);
  I=0;
  FIELD="";
  for FIELD in $DATA;
    do
      let I++;
      if [ $I -eq 1 ];
        then
          FIELD=$($ECHO $FIELD | $CUT -d "_" -f 1);
          $ECHO -n $FIELD:;
        fi
        if [ $I -eq $X ];
          then
            $ECHO "$FIELD";
          fi
          if [ $I -eq 4 ];
            then
              I=0;
            fi;
    done;
}


case "$1" in
  index)
    $SNMPWALK -v $PROTOCOL -c $COMMUNITY $HOSTNAME $OID | $GREP "_in" \
    | $CUT -d '"' -f 2 | $CUT -d "_" -f 1 ;
    
  ;;
  query)
    case "$2" in
      label)
        DATA=$($SNMPWALK -v $PROTOCOL -c $COMMUNITY $HOSTNAME $OID | $GREP "_in" \
        | $CUT -d '"' -f 2 | $CUT -d "_" -f 1) ;
        for FIELD in $DATA;
          do
            $ECHO $FIELD:$FIELD
          done
        ;;
      evalutions-in)
        X=2;
        IO=_in;
        getting_fields;
        ;;
      evalutions-out)
        X=2;
        IO=_out;
        getting_fields;
        ;;
      packets-in)
        X=3;
        IO=_in;
        getting_fields;
        ;;
      packets-out)
        IO=_out;
        X=3;
        getting_fields;
        ;;
      bytes-in)
        X=4;
        IO=_in;
        getting_fields;
        ;;
      bytes-out)
        X=4;
        IO=_out;
        getting_fields;
        ;;
      *)
        $SNMPWALK -v $PROTOCOL -c $COMMUNITY $HOSTNAME $OID \
        | $CUT -d '"' -f 2 | $CUT -d " " -f 1;
        ;;
    esac;
    ;;
  get)
    if [ -z $3 ];
      then
        exit 1
    fi
    case "$2" in
      label)
        X=1;
        IO=_out;
        FIELD=$(getting_fields | $GREP -w "$3" | $CUT -d ":" -f 2);
        $ECHO -n $FIELD;
        ;;
      evalutions-in)
        X=2;
        IO=_in;
        FIELD=$(getting_fields | $GREP -w "$3" | $CUT -d ":" -f 2);
        $ECHO -n $FIELD;
        ;;
      evalutions-out)
        X=2;
        IO=_out;
        FIELD=$(getting_fields | $GREP -w "$3" | $CUT -d ":" -f 2);
        $ECHO -n $FIELD;
        ;;
      packets-in)
        X=3;
        IO=_in;
        FIELD=$(getting_fields | $GREP -w "$3" | $CUT -d ":" -f 2);
        $ECHO -n $FIELD;
        ;;
      packets-out)
        X=3;
        IO=_out;
        FIELD=$(getting_fields | $GREP -w "$3" | $CUT -d ":" -f 2);
        $ECHO -n $FIELD;
        ;;
      bytes-in)
        X=4;
        IO=_in;
        FIELD=$(getting_fields | $GREP -w "$3" | $CUT -d ":" -f 2);
        $ECHO -n $FIELD;
        ;;
      bytes-out)
        X=4;
        IO=_out;
        FIELD=$(getting_fields | $GREP -w "$3" | $CUT -d ":" -f 2);
        $ECHO -n $FIELD;
        ;;
    esac;
    
    ;;
  *)
    $ECHO "Usage:";
    $ECHO "	./query_label.sh index";
    $ECHO "	./query_label.sh query {label,evalutions-in,evalutions-out,packets-in,packets-out,bytes-in,bytes-out}";
    $ECHO "	./query_label.sh get {label,evalutions-in,evalutions-out,packets-in,packets-out,bytes-in,bytes-out} LABEL";
    exit 1;
    ;;
esac;
exit 0;


